Attribute VB_Name = "basMain"
'************************************************************
'*                                                          *
'*                        MP3 Changer                       *
'*             Geschrieben von Wolfgang Ehrhardt            *
'*                        woeh@gmx.de                       *
'*                                                          *
'************************************************************

Option Explicit

Public Declare Function SearchLB Lib "user32" Alias "SendMessageA" (ByVal Hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long

Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
Private Declare Function GetShortPathName Lib "kernel32" Alias "GetShortPathNameA" (ByVal lpszLongPath As String, ByVal lpszShortPath As String, ByVal cchBuffer As Long) As Long
Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal Hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Private Declare Function SetWindowPos Lib "user32" (ByVal Hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cX As Long, ByVal cY As Long, ByVal wFlags As Long) As Long
Private Declare Function GetTempPath Lib "kernel32" Alias "GetTempPathA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Private Declare Function GetTempFileName Lib "kernel32" Alias "GetTempFileNameA" (ByVal lpszPath As String, ByVal lpPrefixString As String, ByVal wUnique As Long, ByVal lpTempFileName As String) As Long
Private Declare Function GetLongPathName Lib "kernel32.dll" Alias "GetLongPathNameA" (ByVal lpszShortPath As String, ByVal lpszLongPath As String, ByVal cchBuffer As Long) As Long

Public BasisDir As String
Public File As String, Path As String, FullPath As String
Public AppExit As Boolean, ReplaceOnly As Boolean

Public UNDOsearchFor As String, UNDOreplaceWith As String
Public UNDOfileAnz As Long
Public UNDOoldFilePath() As Variant, UNDOnewFilePath() As Variant, UNDOfileName() As Variant

Public Type MYTYPE
    Name         As String
    Version      As String
    FullName     As String
    Path         As String
    EXE          As String
    FullPath     As String
    Log          As String
    Frage        As String
    Hinweis      As String
    INI          As String
    eMail        As String
    noMP3Action  As Long
End Type

Public Type ID3V2TAGINFO
    Version          As String
    TagLength        As Long
    ExtendedHeader   As Boolean
    PlayCounter      As Long
    Track            As String
    Encoder          As String
    Link             As String
    Copyright        As String
    OriginalArtist   As String
    Composer         As String
    Genre            As String
    Comment          As String
    Year             As String
    Album            As String
    Artist           As String
    Title            As String
    Language         As String
    length           As Long
    MediaType        As String
    Publisher        As String
    DecodingSoftware As String
    UnknownFrames    As Long
End Type

Public Const CB_FINDSTRINGEXACT = &H158
Public Const LB_FINDSTRINGEXACT = &H1A2
    
Public Const ABC  As String = "abcdefghijklmnopqrstuvwxyz" & _
                              "ABCDEFGHIJKLMNOPQRSTUVWXYZ" & _
                              ""

Public MY As MYTYPE
Public noMP3()

Sub Main()
    Dim R$
    Dim DontShowInfo As Variant

    If App.PrevInstance = True Then
        Beep
        
        End
    End If

    Call GetMyInfo

    Call WriteLog("***** " & MY.Name & " startet *****")
    Call WriteLog("Version " & MY.Version)
    Call WriteLog("Path: " & MY.FullPath)
    Call WriteLog("Log-Path: " & MY.Log)
    Call WriteLog("INI-Path: " & MY.INI & vbCrLf)
    
    DontShowInfo = ReadINI(MY.INI, MY.Name, "DontShowInfo")
    
    If DontShowInfo = "" Then
        MsgBox "Das Programm erwartet das die MP3-Dateien folgendermaen vorliegen:" & vbCrLf & _
               vbCrLf & _
               "Nr - Name.mp3" & vbCrLf & _
               vbCrLf & _
               "Du wrirst merken, das sich so besser mit dem Programm arbeiten lt.", vbInformation + vbOKOnly, "Hinweis"
               
        Call WriteINI(MY.INI, MY.Name, "DontShowInfo", 1)
    End If
    
    R$ = ReadINI(MY.INI, MY.Name, "BasisDir")
    
    If DirExist(R$) Then
        Call SetBasisDir(R$)
    Else
        AppExit = True
    
        Beep

        MsgBox "Es MU ein Basisverzeichnis angegeben werden," & vbCrLf & _
               "da entweder keine INI-Datei existiert oder der " & _
               "gespeicherte Pfad nicht existiert.", _
               vbOKOnly + vbInformation, MY.Hinweis
                        
        frmSelBasisDir.Show 1
    End If
    
    AppExit = False
    
    frmMain.Show
    
End Sub
Public Function DirExist(ByVal Path As String) As Boolean
    Dim FS As Object
   
    On Local Error GoTo Quit
    
    DirExist = False

    If Len(Path) < 3 Then Exit Function
    
    Path = GetDir(Path)
    
    Set FS = CreateObject("Scripting.FileSystemObject")
    
    If FS.FolderExists(Path) Then DirExist = True
    
Quit:
    If Err.Number <> 0 Then Err.Clear
    
    Set FS = Nothing
    
End Function
Private Sub GetMyInfo()

    With MY
        .Name = "MP3 Changer"
        .Version = App.Major & "." & App.Minor & "." & App.Revision
        .FullName = .Name & " " & .Version
        
        .Frage = .Name & " Frage"
        .Hinweis = .Name & " Hinweis"

        .Path = GetDir(App.Path)
        
        .Log = .Path & .Name & ".log"
        .INI = .Path & .Name & ".ini"
        
        .EXE = App.EXEName & ".exe"
        .FullPath = .Path & .EXE
        
        .eMail = "woeh@gmx.de"
    End With
    
End Sub
Public Function SetBasisDir(ByVal Directory As String)

    BasisDir = GetDir(Directory)
    
    Call WriteLog("Set BasisDirectory to " & BasisDir)

End Function
Public Function ReadINI(ByVal INIpath As String, ByVal Section As String, _
                         ByVal Key As String) As String
    Dim RetStr As String
   
    RetStr = String(255, Chr$(0))
   
    ReadINI = Left$(RetStr, GetPrivateProfileString(Section, Key, "", RetStr, Len(RetStr), INIpath))
                                            
End Function
Public Function WriteINI(ByVal INIpath As String, _
                         ByVal Section As String, ByVal Abschnitt As String, _
                         ByVal Value As String) As Boolean
    
    If WritePrivateProfileString(Section, Abschnitt, Value, INIpath) Then WriteINI = True

End Function
Public Function ReadDir(ByVal Directory As String, _
                        DirList As Variant, FileList As Variant)
    Dim File As String
    Dim X As Long, Y As Long
    Dim At As VbFileAttribute, Fa As VbFileAttribute
    
    Erase DirList: Erase FileList
    
    X = 0: Y = 0
    
    At = vbDirectory + vbHidden + vbReadOnly + vbSystem
    
    Directory = GetDir(Directory)
    
    File = Directory
    File = Dir(File & "*.*", At)
    
    On Local Error Resume Next
    
    Do While Len(File)
        If File <> "." And File <> ".." Then
            Fa = (GetAttr(Directory & File) And vbDirectory)
                    
            If Err.Number = 0 Then
                If Fa = vbDirectory Then
                    ReDim Preserve DirList(X)
                    
                    DirList(X) = File
                    X = X + 1
                                        
                    DoEvents
                Else
                    ReDim Preserve FileList(Y)
                    
                    FileList(Y) = File
                    Y = Y + 1
                End If
            Else
                If Err.Number <> 5 Then
                    Err.Clear
                    
                    GoTo Quit
                End If
                
                Err.Clear
            End If
        End If
        
        File = Dir
    Loop
    
Quit:
    
End Function
Public Function GetDir(ByVal Directory As String) As String
    
    GetDir = Directory
    
    If Right$(GetDir, 1) <> "\" Then GetDir = GetDir & "\"

End Function
Public Function WriteLog(LogText As String) As Long
    Dim FN As Integer
    
    LogText = Date & "/" & Time & " --> " & LogText
    
    On Local Error Resume Next
    
    FN = FreeFile
    
    Open MY.Log For Append As FN
         Print #FN, LogText
    Close FN

End Function
Public Sub ExitApp()
    Dim P As Long
    Dim R$
    
    R = frmMain.dlbWorkDir.Path
    
    Call WriteINI(MY.INI, MY.Name, "LastPath", R)
    
    For P = 0 To frmMain.lbGenre.ListCount - 1
        R = frmMain.lbGenre.List(P)
    
        Call WriteINI(MY.INI, "ExtraGenre", CStr(P), R)
    Next P
        
    If BasisDir <> "" Then
        Call WriteINI(MY.INI, MY.Name, "BasisDir", BasisDir)
    End If
    
    Call WriteLog("***** " & MY.Name & " closed *****" & vbCrLf & _
                  vbCrLf & _
                  "(c) by Woeh@gmx.de" & vbCrLf & vbCrLf)
    
End Sub
Public Function isEmpty(Var() As Variant, Optional VarUBound As Long) As Boolean
    
    VarUBound = -1
    
    On Local Error Resume Next
    
    VarUBound = UBound(Var)
    
    If Err.Number <> 0 Then Err.Clear
    
    isEmpty = (VarUBound = -1)
    
End Function
Public Sub DebugFileRename(ByVal OldFile As String, NewFile As String, _
                           Success As Boolean, Optional ErrNumber As Long)
    Dim D$, L$
    
    Select Case Success
        Case True
            D$ = OldFile & " --> " & NewFile
            L$ = "Renaming " & OldFile & " --> " & NewFile
        Case False
            D$ = "ERROR (" & ErrNumber & ") renaming " & OldFile & " --> " & NewFile
            L$ = D$
    
            Err.Clear
    End Select
    
    Call WriteLog(L$)
    Call WriteDebug(D$)
    
End Sub
Public Sub WriteDebug(DebugText As String)

    On Local Error Resume Next

    With frmRename.txtDebug
        .TEXT = .TEXT & DebugText & vbCrLf
        
        If Err.Number <> 0 Then
             .TEXT = DebugText & vbCrLf
        
            Err.Clear
        End If
        
        .SelStart = Len(.TEXT)
    End With
    
    DoEvents

End Sub
Public Function Get_ShortPath(ByVal Path As String) As String
    Dim Result As Long
    Dim aa As String
    
    aa = Space$(255)
    Result = GetShortPathName(Path, aa, Len(aa))
    Get_ShortPath = Mid(aa, 1, Result)

End Function
Public Function Create_File(ByVal File As String) As Long
    Dim FN As Integer
        
    On Local Error GoTo Here
    
    Kill (File)
    
Here:
    Err.Clear

    FN = FreeFile
    
    Open File For Output As FN
    Close FN

    Exit Function
    
Quit:
    Create_File = Err.Number

    Err.Clear

End Function
Public Function Error(ByVal ErrNumber As Long, ErrDescription As String)

    MsgBox "Folgender Fehler trat auf:" & vbCrLf & vbCrLf & _
           ErrDescription, vbCritical + vbOKOnly, "Fehler (" & ErrNumber & ")"

End Function
Public Function FindDir(ByVal DirToFind As String, _
                        ByVal StartDir As String, DirList() As Variant) As Long
    Dim P As Long, UB As Long
    Dim FileList()
    Dim Pat As String
    
    DirToFind = UCase(DirToFind)
    
    Call ReadDir(StartDir, DirList, FileList)
    
    If isEmpty(DirList, UB) = False Then
        For P = 0 To UB
            Pat = UCase(StartDir & DirList(P))
        
            If DirToFind = Pat Then
                FindDir = P
            
                Exit Function
            End If
        Next P
    End If
    
    FindDir = -1
    
End Function
Public Function StringToArtist(str As String, Artist As String, Album As String) As Boolean
    Dim t() As String
    Dim P As Long
    
    On Local Error GoTo Error
    
    t = Split(str, " - ")
    
    Artist = t(0)
    Album = ""
    
    For P = 1 To UBound(t)
        If P > 1 Then
            Album = Album & " - " & t(P)
        Else
            Album = t(1)
        End If
    Next P

    If UBound(t) = 0 Then GoTo Error
    
    StringToArtist = True
    
    Exit Function
    
Error:
    Call ParseError
    
    StringToArtist = False
    
End Function
Public Function ParseString(ByVal Path As String, _
                             Artist As String, Album As String) As Boolean
    Dim R$
    Dim P As Long
    Dim Found As Boolean
    
    If Right$(Path, 1) = "\" Then Path = Mid(Path, 1, Len(Path) - 1)
     
    For P = Len(Path) To 1 Step -1
        If Mid(Path, P, 1) = "\" Then
            R$ = Mid(Path, P + 1)
            
            Found = True
            
            Exit For
        End If
    Next P
    
    If Found = False Then
        ParseString = False
        
        Exit Function
    End If
    
    If StringToArtist(R$, Artist, Album) = False Then
        ParseString = False
        
        Exit Function
    End If
    
    ParseString = True
    
End Function
Public Function FileExist(ByVal File As String) As Boolean
    Dim FN As Integer

    On Local Error GoTo Quit
    
    FileExist = False
    
    FN = FreeFile
    
    Open File For Input As FN
    Close FN

    FileExist = True
    
    Exit Function
    
Quit:
    FileExist = False
    
    Err.Clear
    
End Function
Public Sub ParseError()

    MsgBox "Es konnte nicht ohne Fehler geparst werden." & vbCrLf & _
           "Der Verzeichnisname sollte folgendermaen vorliegen:" & vbCrLf & vbCrLf & _
           "Artist - Album", vbCritical + vbOKOnly, "Fehler beim Parsen"

End Sub
Public Function Execute(Path As String, Optional Param As String = "", _
                        Optional WinStyle As VbAppWinStyle = vbNormalFocus) As Boolean
    Dim Result As Long
    
    Result = ShellExecute(frmMain.Hwnd, "Open", Path, Param, "", WinStyle)

    If Result > 32 Then Execute = True

End Function
Public Sub StayOnTop(ByVal Hwnd As Long, ByVal RemoveFromTop As Boolean)
    Dim hWndInsertAfter As Long
    
    Const HWND_NOTOPMOST = -2
    Const HWND_TOPMOST = -1
    Const SWP_NOSIZE = &H1
    Const SWP_NOMOVE = &H2

    If RemoveFromTop = True Then
        hWndInsertAfter = HWND_NOTOPMOST
    Else
        hWndInsertAfter = HWND_TOPMOST
    End If
    
    Call SetWindowPos(Hwnd, hWndInsertAfter, 0, 0, 0, 0, SWP_NOSIZE Or SWP_NOMOVE)
    
End Sub
Public Sub AddGenre(cb As ComboBox)
    Dim R$, Genre() As String
    Dim P As Long
    
    
    R = "Blues,Classic Rock,Country,Dance,Disco,Funk,Grunge,Hip Hop,Jazz,Metal,New Age," & _
        "Oldies,Other Genre,Pop,RNB,Rap,Reggae,Rock,Hard Rock,Techno,Industrial,Alternative," & _
        "Jazz and Funk,Fusion,Trance,Classical,Instrumental,Acid,House,Game,Sound Clip," & _
        "Gospel,Noise,Alternative Rock,Bass,Soul,Punk,Space Genre,Meditative,Instrumental Pop," & _
        "Instrumental Rock,Ethnic,Gothic Rock,Darkwave,Techno Industrial,Electronic,Pop Folk," & _
        "Eurodance,Dream,Southern Rock,Comedy,Cult,Gangsta,Top 40,Christian Rap,Pop Funk," & _
        "Jungle,Native American,Cabaret,New Wave,Psychedelic,Rave,Showtunes,Trailer,LoFi," & _
        "Tribal,Acid Punk,Acid Jazz,Polka,Retro,Musical,Rock'n'Roll,Hard Rock,Folk,Folk Rock," & _
        "National Folk,Swing,Fast Fusion,Bebob,Latin,Revival,Celtic,Bluegrass,Avantgarde," & _
        "Progressive Rock,Gothic,Psychedelic Rock,Symphonic Rock,Slow Rock,Big Band,Chorus," & _
        "Easy Listening,Acoustic,Humor,Speech,Chanson,Opera,Chamber Music,Sonata,Symphony," & _
        "Booty Bass,Primus,Porn Groove,Satire,Slow Jam,Club,Tango,Samba,Folklore,Ballad," & _
        "Power Ballad,Rhythmic Soul,Freestyle,Duet,Punk Rock,Drum Solo,A Cappella,Euro House," & _
        "Dance Hall,Goa,Drum'n'Bass,Club House,Hardcore,Terror,Indie,Brit Pop,Negerpunk,PolskPunk," & _
        "Beat,Christian Gangsta Rap,Heavy Metal,Black Metal,Crossover,Contemporary Christian," & _
        "Christian Rock,Merengue,Salsa,Thrash Metal,Anime,JPop,Synthpop,Death Metal"
    
    Genre = Split(R, ",")
    
    For P = 0 To UBound(Genre)
        cb.AddItem Genre(P)
    Next P

End Sub
Public Function IsMultiSelected(lb As ListBox, SelectedItems As Long) As Boolean
    Dim P As Long, X As Long
    
    X = 0
    
    For P = 0 To lb.ListCount - 1
        If lb.Selected(P) = True Then
            X = X + 1
            
            If X > 1 Then IsMultiSelected = True
        End If
    Next P
    
    If X = 0 Then
        IsMultiSelected = False
        
        Exit Function
    End If
    
    SelectedItems = X
    
End Function
Public Function MP3_ReadID3v2Tag(ByVal File As String, ID3Tag As ID3V2TAGINFO, _
                                 Optional ErrorNumber As Long) As Boolean
    Dim Mp3FileContent As String, ID3Length As String, ID3Version As String
    Dim FrameName As String, FrameLen As String, FrameFlags As String, ID3V2Tag As String
    Dim ID3Position As Long, lngID3Length As Long, lngFrameLen As Long
    Dim FN As Integer
       
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    If FileExist(File) = False Then Exit Function

    FN = FreeFile
    
    Open File For Binary As #FN
        Mp3FileContent = String$(LOF(FN), "!")
        Get #FN, , Mp3FileContent
    Close #FN

    ID3Position = InStr(Mp3FileContent, "ID3")
    If ID3Position = 0 Then Exit Function
    
    ID3Version = Mid$(Mp3FileContent, ID3Position + 3, 2)
    
    If Asc(Left$(ID3Version, 1)) <> 2 And Asc(Left$(ID3Version, 1)) <> 3 And _
       Asc(Left$(ID3Version, 1)) <> 4 Then Exit Function
    
    ID3Tag.Version = str$(Asc(Left$(ID3Version, 1))) & "." & _
                     Trim$(str$(Asc(Right$(ID3Version, 1))))
    
    ID3Length = Mid$(Mp3FileContent, ID3Position + 6, 4)
    
    lngID3Length = &H200000 * Asc(Left$(ID3Length, 1)) + &H4000 * Asc(Mid$(ID3Length, _
                   2, 1)) + &H80 * Asc(Mid$(ID3Length, 3, 1)) + Asc(Mid$(ID3Length, 4, 1))
    
    ID3Tag.TagLength = lngID3Length
    
    ID3V2Tag = Mid$(Mp3FileContent, ID3Position, lngID3Length + 10)
    
    Mp3FileContent = ""

    If (Asc(Mid$(ID3V2Tag, 6, 1)) And 32) = 32 Then
        ID3Tag.ExtendedHeader = True
        ID3V2Tag = Mid$(ID3V2Tag, 10)
    End If
    
    ID3V2Tag = Mid$(ID3V2Tag, 11)

    ID3Tag.UnknownFrames = 0

    Do
        If Asc(Left$(ID3Version, 1)) = 3 Or Asc(Left$(ID3Version, 1)) = 4 Then
            FrameName = Left$(ID3V2Tag, 4)
                 
            If Left$(FrameName, 3) = "3DI" Then Exit Do
                FrameLen = Mid$(ID3V2Tag, 5, 4)
                lngFrameLen = 256 * 8 * 8 * Asc(Left$(FrameLen, 1)) + 256 * 8 * Asc(Mid$(FrameLen, _
                                  2, 1)) + 256 * Asc(Mid$(FrameLen, 3, 1)) + Asc(Mid$(FrameLen, 4, 1))
            
                FrameFlags = Mid$(ID3V2Tag, 9, 2)
                ID3V2Tag = Mid$(ID3V2Tag, 11)
            
                Select Case FrameName
                    Case "PCNT"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.PlayCounter = Val(Mid$(ID3V2Tag, 2, lngFrameLen - 1))
                        Else
                            ID3Tag.PlayCounter = Val(Left$(ID3V2Tag, lngFrameLen))
                        End If
                    Case "TRCK"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Track = Val(Mid$(ID3V2Tag, 2, lngFrameLen - 1))
                            If CLng(ID3Tag.Track) < 10 Then ID3Tag.Track = "0" & ID3Tag.Track
                        Else
                            ID3Tag.Track = Val(Left$(ID3V2Tag, lngFrameLen))
                        End If
                    Case "TENC"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Encoder = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Encoder = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "WXXX"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Link = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Link = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TCOP"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Copyright = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Copyright = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TOPE"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.OriginalArtist = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.OriginalArtist = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TCOM"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Composer = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Composer = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TCON"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Genre = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Genre = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "COMM"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Comment = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Comment = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TYER"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Year = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Year = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TALB"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Album = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Album = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TPE1"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Artist = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Artist = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TIT2"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Title = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Title = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TLAN"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Language = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Language = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TLEN"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.length = Val(Mid$(ID3V2Tag, 2, lngFrameLen - 1))
                        Else
                            ID3Tag.length = Val(Left$(ID3V2Tag, lngFrameLen))
                        End If
                    Case "TMED"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.MediaType = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.MediaType = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TPUB"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Publisher = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Publisher = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TSSE"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.DecodingSoftware = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.DecodingSoftware = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case Else
                        ID3Tag.UnknownFrames = ID3Tag.UnknownFrames + 1
                End Select
            
                ID3V2Tag = Mid$(ID3V2Tag, lngFrameLen + 1)
            ElseIf Asc(Left$(ID3Version, 1)) = 2 Then
                FrameName = Left$(ID3V2Tag, 3)
                If FrameName = "3DI" Then Exit Do
            
                FrameLen = Mid$(ID3V2Tag, 4, 3)
                lngFrameLen = 256 * 8 * Asc(Left$(FrameLen, 1)) + 256 * Asc(Mid$(FrameLen, 2, _
                              1)) + Asc(Mid$(FrameLen, 3, 1))
            
                ID3V2Tag = Mid$(ID3V2Tag, 7)
            
                Select Case FrameName
                    Case "TRK"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Track = Val(Mid$(ID3V2Tag, 2, lngFrameLen - 1))
                        Else
                            ID3Tag.Track = Val(Left$(ID3V2Tag, lngFrameLen))
                        End If
                    Case "TEN"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Encoder = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Encoder = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TCR"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Copyright = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Copyright = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TOA"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.OriginalArtist = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.OriginalArtist = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TCM"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Composer = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Composer = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TCO"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Genre = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Genre = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "COM"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Comment = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Comment = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TYE"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Year = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Year = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TAL"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Album = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Album = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TP1"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Artist = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Artist = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TT2"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Title = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Title = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TLA"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.Language = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.Language = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TMT"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.MediaType = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.MediaType = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case "TSS"
                        If Left$(ID3V2Tag, 1) = Chr$(0) Then
                            ID3Tag.DecodingSoftware = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                        Else
                            ID3Tag.DecodingSoftware = Left$(ID3V2Tag, lngFrameLen)
                        End If
                    Case Else
                        ID3Tag.UnknownFrames = ID3Tag.UnknownFrames + 1
                End Select
            
                ID3V2Tag = Mid$(ID3V2Tag, lngFrameLen + 1)
            End If
    Loop Until Len(ID3V2Tag) = 0
    
    MP3_ReadID3v2Tag = True

    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Err.Clear

End Function
Public Function Get_LongPath(ByVal Path As String) As String
    Dim Result As Long
    Dim aa As String
    
    aa = Space$(255)
    Result = GetLongPathName(Path, aa, Len(aa))
    Get_LongPath = Mid$(aa, 1, Result)

End Function
Public Function TempFile_Create() As String
    Dim Result As Long
    Dim str As String, Buff As String, Dir As String

    Const MAX_PATH = 260

    str = String(MAX_PATH, 0)
    Result = GetTempPath(MAX_PATH, str)
            
    If Result Then Dir = Left$(str, InStr(str, Chr$(0)) - 1)

    Buff = Space$(MAX_PATH)
    
    If GetTempFileName(Dir, "~", 0&, Buff) <> 0 Then
        Result = InStr(1, Buff, Chr$(0))
            
        If Result Then
            TempFile_Create = Buff
            TempFile_Create = Left$(Buff, Result - 1)
            TempFile_Create = Get_LongPath(TempFile_Create)
        End If
    End If
    
End Function
Public Function TextFile_WriteText(ByVal File As String, _
                                   ByVal TEXT As String) As Long
    Dim FN As Integer
        
    On Local Error GoTo Quit
    
    FN = FreeFile
    
    Open File For Output As FN
        Print #FN, TEXT
    Close FN

    Exit Function

Quit:
    TextFile_WriteText = Err.Number

    Err.Clear
    
End Function
Public Function TextFile_Read(ByVal File As String) As String
     Dim FN As Integer
    
    On Local Error GoTo Quit
    
    FN = FreeFile()
    
    Open File For Binary Access Read As #FN
        TextFile_Read = Space(LOF(FN))
        Get #FN, , TextFile_Read
    Close #FN
    
    Exit Function
    
Quit:
    If Err.Number <> 0 Then
        Call Error(Err.Number, Err.Description)
    End If
    
End Function
